/* 01-Mai-2007
   Copyright: H.Helmke, F. Hoeppner
   siehe Buch: Kapitel 8
   Netzplanung mit Zeiger-Semantik
   C++-Version von DynVorgangsArray
*/

#include "DynVorgangsArray.h"
#include <cstdlib>  // wg. NULL

/** Initialisierung von Zeiger und Anzahl */
DynVorgangsArray::DynVorgangsArray() {
   anz = 0;
   array = NULL;
}



/** Freigabe des Heapspeichers  */
DynVorgangsArray::~DynVorgangsArray() {
   delete[] array;
   array = NULL;
   anz = 0;
}


/** Vorgang v wird dem dynamischen
Vorgangsarray hinzugefgt. Hierbei
muss der Speicherplatz auf dem Heap, den
arr belegt um 1 vergrert werden bzw.
sogar erst angefordert werden.  */
void DynVorgangsArray::fuegeHinzu(Vorgang* v) {
   // Speicherplatz fuer einen mehr
   Vorgang** tmp = 
          new TP_Vorgang[anz+1];
   // bisherigen Inhalt retten
   for (int i=0; i < anz; ++i) {
      tmp[i] = array[i];
   }
   // Neuen Eintrag eintragen
   tmp[anz] = v;
   ++anz;
   // bisherigen Speicher freigeben
   delete [] array;
   // Zeiger umbiegen
   array = tmp;
}

/** Kommt Vorgang *v in array vor?*/
bool DynVorgangsArray::istElem
   (const Vorgang* v) const {
   for (int i=0; i < anz; ++i) {
      if (array[i] == v) {
         return true;
   } }
   return false;
}

