/* 01-Mai-2007
   Copyright: H.Helmke, F. Hoeppner
   siehe Buch: Kapitel 4, 8
   Netzplanung mit Zeiger-Semantik
   C++-Version: Header-Datei von Vorgang
*/

#ifndef VORGANG_HEADER
#define VORGANG_HEADER

#include "DynVorgangsArray.h"

class Vorgang {
public:
   Vorgang();
   ~Vorgang();

   void ausgabeVorgang() const;
   bool istDurchfuehrbar() const;
   void passeFruehanfAn(const Vorgang* vv);
   void passeSpaetEndAn(const Vorgang* vn);
   void setzeNachf(Vorgang* vn);
   bool istVorgaengerVon(const Vorgang* vn) const;
   void setDauer(double d);
   double getFruehanf() const;
	double getSpaetend() const;

private:
   double dauer;
   double fruehanf;
   double spaetend;

   DynVorgangsArray vorgaenger;
   DynVorgangsArray nachfolger;

   friend void berechneVorwaerts(int v, struct Netz *netz);
   friend void berechneRueckwaerts(int v, struct Netz *netz);
};

#endif /* VORGANG_HEADER */
